/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

/**********************************************************************

	--- Qt Architect generated file ---

	File: player.cpp
	Last generated: Thu Jan 14 03:06:57 1999

 *********************************************************************/

#include "player.h"
#include <fcntl.h>
#include <stdio.h>
#include <sys/soundcard.h>
#include <qtimer.h>
#include <qslider.h>

#define Inherited playerData

extern cnf mconf;
cnf aconf;

player::player
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
aconf=mconf;
aconf.dev.f=0;
aconf.wave.window_start_pn=0;
aconf.wave.window_start=0;
aconf.wave.window_length_pn=512;
aconf.wave.ido=aconf.wave.rec_pn/aconf.wave.freq;
aconf.wave.window_length=aconf.wave.window_length_pn/aconf.wave.freq;
scrn->init_cfg(&aconf);
lp_start_pn=0;
lp_start=0;
lp_end_pn=aconf.wave.rec_pn;
lp_end=aconf.wave.ido;
lp=FALSE;
wave_sl->close();
wave_sl=new QSlider (0,aconf.wave.ido*100,100,0,QSlider::Horizontal,this);	
wave_sl->resize(315,20);
wave_sl->move(10,115);
wave_sl->setTickmarks(QSlider::Above);
wave_sl->setTracking(TRUE);
connect(wave_sl,SIGNAL(sliderMoved(int)),SLOT(sld_move(int)));
timer=new QTimer();
connect(timer,SIGNAL(timeout()),SLOT(do_play())); 
}

void player::openf()
{
int a=aconf.wave.freq;

if ((aconf.dev.f=open(aconf.dev.dev,O_WRONLY||O_NONBLOCK))>0);
ioctl(aconf.dev.f,SNDCTL_DSP_SPEED,&a);
a=128;
ioctl(aconf.dev.f,SNDCTL_DSP_GETBLKSIZE,&a);
ioctl(aconf.dev.f,SNDCTL_DSP_SYNC);
ioctl(aconf.dev.f,SNDCTL_DSP_NONBLOCK);
}

void player::update_info()
{
int ido;

aido->display((ido=(int)((float)aconf.wave.window_start_pn/((float)aconf.wave.freq/(float)100))));
wave_sl->setValue(ido);
scrn->repaint();
}


void player::sld_move(int i)
{
  aconf.wave.window_start_pn=i*aconf.wave.freq/100;
  aconf.wave.window_start=i;
  if (timer->isActive)
     update_info();
}

void player::set_lp_start()
{
   lp_start=aconf.wave.window_start_pn/(aconf.wave.freq/100); 
   lp_start_pn=aconf.wave.window_start_pn; 
   lp_d_start->setValue(lp_start);
}

void player::lp_start_ch(int i)
{
  lp_start=i;
  lp_start_pn=i*(aconf.wave.freq/100);
}

void player::lp_end_ch(int i)
{
  lp_end=i;
  lp_end_pn=i*(aconf.wave.freq/100);
}

void player::set_lp_end()
{
   lp_end=aconf.wave.window_start_pn/(aconf.wave.freq/100);  
   lp_end_pn=aconf.wave.window_start_pn;
   lp_d_end->setValue(lp_end);
}

void player::set_lp(bool i)
{
  lp=i;
}

void player::stop()
{
  timer->stop();
  closef();
}

void player::pause(bool i)
{
   if (i)
        timer->stop();
   else 
	timer->start(((float)aconf.wave.window_length_pn/(float)aconf.wave.freq)*500,FALSE);
}

void player::do_play()
{
audio_buf_info abi;
if (aconf.dev.f>0){
  fsync(aconf.dev.f);
  ioctl(aconf.dev.f,SNDCTL_DSP_GETOSPACE,&abi);
  if (abi.fragstotal-abi.fragments<=1){
    update_info();
    write(aconf.dev.f,(aconf.wave.wave+aconf.wave.window_start_pn),aconf.wave.window_length_pn);
    fsync(aconf.dev.f);
    if (lp==FALSE){
      if (aconf.wave.window_start_pn<aconf.wave.rec_pn){
         aconf.wave.window_start_pn+=aconf.wave.window_length_pn;
         aconf.wave.window_start=aconf.wave.window_start_pn/aconf.wave.freq;
      }
      else {
           timer->stop();
           aconf.wave.window_start_pn=0;
           aconf.wave.window_start=0;
           closef();
           update_info();
      }
    }  
    else {
        if (aconf.wave.window_start_pn>=lp_end_pn){
  	   aconf.wave.window_start_pn=lp_start_pn;
	   aconf.wave.window_start=lp_start;
	   update_info();	 
        }
        else {
	   aconf.wave.window_start_pn+=aconf.wave.window_length_pn;
           aconf.wave.window_start=aconf.wave.window_start_pn/aconf.wave.freq;
	   update_info();
        }
    }
  }
}
}

void player::closef()
{
if (aconf.dev.f>0)
   file_close(aconf.dev.f);
aconf.dev.f=0;
}

void player::play()
{
if (aconf.dev.f==0){
  openf();
  timer->start(((float)aconf.wave.window_length_pn/(float)aconf.wave.freq)*500,FALSE);
//timer->start(0,FALSE);
}
}

void player::cancel()
{
  close();
}

player::~player()
{
}
